/* Terraform - (C) 1997-1999 Robert Gasch (Robert_Gasch@peoplesoft.com)
 *  - www.peoplesoft.com/peoplepages/g/robert_gasch/terraform/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */


#ifndef _TF_FILE_RC
#define _TF_FILE_RC

#include <stdio.h>
#include "glib--glist.h"
#include "FileIO.h"
#include "TFOptionsTable.h"


/*
 *  TFFileRC: class to handle some high level file operations
 */
class TFFileRC : public FileIO
	{
	public:
					TFFileRC (const char *fName, TFOptionsTable *optTbl);
					~TFFileRC ();
		void		writeRCFile (TFOptionsTable *optTbl);
		TFOptionsTable *parseRCFile ();
		int			parseOption (char *buf);

	protected:
		int				d_items, d_lines;
		TFOptionsTable	*d_optTable;
	};


#endif // _TF_FILE_RC

