/* Terraform - (C) 1997-1999 Robert Gasch (Robert_Gasch@peoplesoft.com)
 *  - www.peoplesoft.com/peoplepages/g/robert_gasch/terraform/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */


#ifndef _TF_OPEN_GL_AREA_H
#define _TF_OPEN_GL_AREA_H
 

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glx.h>

#include <gtk--.h>
#include <gtkgl--/glarea.h>

#include "HeightFieldDraw.h"



/*
 * TFOpenGLArea
 * 	This class will be our OpenGL widget of three geometric objects
 */
class TFOpenGLArea:public Gtk_GLArea
{
	public:
				TFOpenGLArea (HeightField *HF);
				~TFOpenGLArea ();

		// take over the impl functions for events 
		virtual void 	realize_impl ();
		virtual gint 	expose_event_impl (GdkEventExpose *e);
		virtual gint 	configure_event_impl (GdkEventConfigure *e);
		virtual gint 	button_press_event_impl (GdkEventButton *e); 
		virtual gint	key_press_event_impl (GdkEventKey *e); 

	private:
		void 		drawTerrain ();
		void		buildMesh (); 
		void 		initGL ();
		void 		setupGL ();
		void 		drawGL ();

		HeightField		*d_HF;
		HeightFieldDraw		*d_HFD;

		GLuint 			d_terrainList, 		// display lists
					d_normalsList;
		GLfloat			***d_meshVertices;	// mesh vertices 
		GLfloat			***d_meshNormals;	// mesh normals 
		GLuint     		d_meshColumnStep;	// column step factor 1 = all points 
		GLuint     		d_meshRowStep;		// row step factor 1 = all points 
		GLboolean  		d_doDrawNormals;	// draw the normals? 
};


#endif

